【题解】codeforces451E Devu and Flowers 容斥原理+组合计数

Description

Devu wants to decorate his garden with flowers. He has purchased n boxes, where the i-th box contains fi
flowers. All flowers in a single box are of the same color (hence they are indistinguishable). Also, no two boxes have flowers of the same color.

Now Devu wants to select exactly s flowers from the boxes to decorate his garden. Devu would like to know, in how many different ways can he select the flowers from each box? Since this number may be very large, he asks you to find the number modulo (109 + 7).

Devu considers two ways different if there is at least one box from which different number of flowers are selected in these two ways.

Input

The first line of input contains two space-separated integers n and s (1 ≤ n ≤ 20, 0 ≤ s ≤ 1014).

The second line contains n space-separated integers f1, f2, … fn (0 ≤ fi ≤ 1012).

Output

Output a single integer — the number of ways in which Devu can select the flowers modulo (109 + 7).

Examples

Input
2 3
1 3
Output
2
Input
2 4
2 2
Output
1
Input
3 5
1 3 2
Output
3

Note

Sample 1. There are two ways of selecting 3 flowers: {1, 2} and {0, 3}.

Sample 2. There is only one way of selecting 4 flowers: {2, 2}.

Sample 3. There are three ways of selecting 5 flowers: {1, 2, 2}, {0, 3, 2}, and {1, 3, 1}.


详见李煜东《算法竞赛进阶指南》P172

#include
#include
using namespace std;
typedef long long ll;
ll a[25],m,ans;
int inv[25],n;
const int mod=1000000007;
int qpow(int a,int b)
{
    int ret=1;
    for(;b;b>>=1)
    {
        if(b&1)ret=(ll)ret*a%mod;
        a=(ll)a*a%mod;
    }
    return ret;
}
int c(ll y,int x)
{
    if(y<0||x<0||yreturn 0;
    y%=mod;
    if(x==0||y==0)return 1;
    int ret=1;
    for(int i=0;imod;
    for(int i=1;i<=x;i++)ret=(ll)ret*inv[i]%mod;
    return ret;
}
int main()
{
    //freopen("in.txt","r",stdin);
    std::ios::sync_with_stdio(false);
    cin>>n>>m;
    for(int i=1;i<=20;i++)inv[i]=qpow(i,mod-2);
    for(int i=1;i<=n;i++)cin>>a[i];
    for(int x=0;x<1<if(x==0)ans=(ans+c(n+m-1,n-1))%mod; 
        else
        {
            ll t=n+m;
            int p=0;
            for(int i=0;iif(x>>i&1)p++,t-=a[i+1];
            t-=p+1;
            if(p&1)ans=(ans-c(t,n-1))%mod;
            else ans=(ans+c(t,n-1))%mod;
        }
    }
    cout<<(ans+mod)%mod<return 0;
}

总结

容斥原理与多重集组合数

你可能感兴趣的:(算法竞赛进阶指南,codeforces,容斥原理,组合数)